from . import updaters

datapartsBitlengths = {}
datapartsTypes = {}

datapartsBitlengths['1'] = (6, 2, 30, 4, 8, 10, 1, 28, 27, 12, 9, 6, 2, 3, 1, 19)
datapartsTypes['1'] = ("u", "u", "u", "e", "I3", "U1", "b", "I4", "I4", "U1", "u", "u", "e", "x", "b", "u")
class messageType_1():
    def __init__(self, dataParts):
        self.name = "[Type 1] Position Report Class A"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Navigation Status", "Rate of Turn", "Speed Over Ground",
            "Position Accuracy", "Longitude", "Latitude", "Course Over Ground", "True Heading", "Time Stamp", 
            "Maneuver Indicator", "RAIM flag", "Radio status"
            ]
        updaters.updateType_1(self)

datapartsBitlengths['2'] = (6, 2, 30, 4, 8, 10, 1, 28, 27, 12, 9, 6, 2, 3, 1, 19)
datapartsTypes['2'] = ("u", "u", "u", "e", "I3", "U1", "b", "I4", "I4", "U1", "u", "u", "e", "x", "b", "u")
class messageType_2():
    def __init__(self, dataParts):
        self.name = "[Type 2] Position Report Class A (Assigned schedule)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Navigation Status", "Rate of Turn", "Speed Over Ground",
            "Position Accuracy", "Longitude", "Latitude", "Course Over Ground", "True Heading", "Time Stamp", 
            "Maneuver Indicator", "RAIM flag", "Radio status"
            ]
        updaters.updateType_2(self)

datapartsBitlengths['3'] = (6, 2, 30, 4, 8, 10, 1, 28, 27, 12, 9, 6, 2, 3, 1, 19)
datapartsTypes['3'] = ("u", "u", "u", "e", "I3", "U1", "b", "I4", "I4", "U1", "u", "u", "e", "x", "b", "u")
class messageType_3():
    def __init__(self, dataParts):
        self.name = "[Type 3] Position Report Class A (Response to interrogation)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Navigation Status", "Rate of Turn", "Speed Over Ground",
            "Position Accuracy", "Longitude", "Latitude", "Course Over Ground", "True Heading", "Time Stamp", 
            "Maneuver Indicator", "RAIM flag", "Radio status"
            ]
        updaters.updateType_3(self)

datapartsBitlengths['4'] = (6, 2, 30, 14, 4, 5, 5, 6, 6, 1, 28, 27, 4, 10, 1, 19)
datapartsTypes['4'] = ("u", "u", "u", "u", "u", "u", "u", "u", "u", "b", "I4", "I4", "e", "x", "b", "u")
class messageType_4():
    def __init__(self, dataParts):
        self.name = "[Type 4] Base Station Report"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Year", "Month", "Day", "Hour", "Minute", "Second", "Fix quality", 
            "Longitude", "Latitude", "Type of EPFD", "RAIM flag", "SOTDMA state"
            ]
        updaters.updateType_4(self)

datapartsBitlengths['5'] = (6, 2, 30, 2, 30, 42, 120, 8, 9, 9, 6, 6, 4, 4, 5, 5, 6, 8, 120, 1, 1)
datapartsTypes['5'] = ("u", "u", "u", "u", "u", "t", "t", "e", "u", "u", "u", "u", "e", "u", "u", "u", "u", "U1", "t", "b", "x")
class messageType_5():
    def __init__(self, dataParts):
        self.name = "[Type 5] Static and Voyage Related Data"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "AIS Version", "IMO Number", "Call Sign", "Vessel Name", "Ship Type",
            "Dimension to Bow", "Dimension to Stern", "Dimension to Starboard", "Position Fix Type", "ETA month (UTC)", "ETA day (UTC)",
            "ETA hour (UTC)", "ETA minute (UTC)", "Draught", "Destination", "DTE"
            ]
        updaters.updateType_5(self)

datapartsBitlengths['6_1'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 30, 4, 5, 5, 6, 30, 4, 5, 5, 6, 120, 24, 13, 10, 2, 3)
datapartsTypes['6_1'] = ("u", "u", "u", "u", "u", "u", "x", "u", "u", "t", "u", "u", "u", "u", "t", "u", "u", "u", "u", "t", "t", "u", "u", "e", "x")
class messageType_6_1():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO236 Dangerous Cargo Indication"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", "DAC",
            "FID", "Last Port Of Call", "ETA month (UTC, Last)", "ETA day (UTC, Last)", "ETA hour (UTC, Last)", "ETA minute (UTC, Last)",
            "Next Port Of Call", "ETA month (UTC, Next)", "ETA day (UTC, Next)", "ETA hour (UTC, Next)", "ETA minute (UTC, Next)", "Main Dangerous Good",
            "IMD Category", "UN Number", "Amount of Cargo", "Unit of Quantity"
            ]
        updaters.updateType_6_1(self)

# UWAGA: typ z tablicą zestawów pól (max 3 elementy - zestawy)
datapartsBitlengths['6_2'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 4, 5)
datapartsTypes['6_2'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "u")
class messageType_6_2():
    def __init__(self, dataParts, tidalInfoArray):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO236 Tidal Window"
        self.dataParts = dataParts
        self.tidals = tidalInfoArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", "DAC",
            "FID", "Month", "Day"
            ]
        updaters.updateType_6_2(self)

datapartsBitlengths['6_3'] = (6, 2, 30, 2, 10, 6, 14, 3)
datapartsTypes['6_3'] = ("u", "u", "u", "x", "u", "u", "u", "x")
class messageType_6_3():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO236 Number of persons on board"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Number Of Persons On Board"
            ]
        updaters.updateType_6_3(self)

datapartsBitlengths['6_4'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 13, 35)
datapartsTypes['6_4'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "x")
class messageType_6_4():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Number of persons on board"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Number Of Persons On Board"
            ]
        updaters.updateType_6_4(self)

datapartsBitlengths['6_5'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 10, 4, 5, 5, 6, 120, 30, 25, 24, 43)
datapartsTypes['6_5'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "u", "u", "u", "u", "t", "t", "I3", "I3", "x")
class messageType_6_5():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Clearance Time To Enter Port"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Message Linkage ID", "Month (UTC)", "Day (UTC)", "Hour (UTC)", "Minute (UTC)", "Name of Port and Berth",
            "Destination", "Longitude", "Latitude"
            ]
        updaters.updateType_6_5(self)

datapartsBitlengths['6_6'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 10, 9, 8, 3, 4, 5, 5, 6, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 120, 25, 24)
datapartsTypes['6_6'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "u", "U1", "e", "u", "u", "u", "u", "b", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "t", "I3", "I3")
class messageType_6_6():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Berthing Data (addressed)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Message Linkage ID", "Berth length", "Berth Water Depth", "Mooring Position", "Month (UTC)", 
            "Day (UTC)", "Hour (UTC)", "Minute (UTC)", "Services Availability", "Agent", "Bunker/fuel", "Chandler", "Stevedore",
            "Electrical", "Potable water", "Customs house", "Cartage", "Crane(s)", "Lift(s)", "Medical facilities", "Navigation repair",
            "Provisions", "Ship repair", "Surveyor", "Steam", "Tugs", "Waste disposal (solid)", "Waste disposal (liquid)", "Waste disposal (hazardous)",
            "Reserved ballast exchange", "Regional reserved 1", "Regional reserved 2", "Reserved for future 1", "Reserved for future 2",
            "Name of Berth", "Longitude", "Latitude"
            ]
        updaters.updateType_6_6(self)

# W skład wiadomości wchodzi 10 tablic danych o kształcie (nie wiem czego, nie ma to znaczenia)
# Zawartość tablicy zależy od typu (informacja poprzedzająca tablicę); każda tablica (zestaw), niezależnie od typu, ma 84 bity
# Typ kształtu (unsigned int) ma 3 bity, więc razem z resztą danych kształtu zajmowane jest przez 1 kształt 87 bitów - trzeba w dekoderze ręcznie wpisać tę
#   trójkę (nie pobierać z krotki); i zależnie od typu tworzyć inny obiekt kształtu, który będzie dodawany do tablicy kształtów
# Klasy dla poszczególnych tablic umieszczone są w pliku arrays_agregates.py
# Parametr shapeDataArrays to tablica dwuwymiarowa zawierająca wszystkie, jednowymiarowe tablice danych
datapartsBitlengths['6_7'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 10, 7, 4, 5, 5, 6, 18)
datapartsTypes['6_7'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "e", "u", "u", "u", "u", "u")
class messageType_6_7():
    def __init__(self, dataParts, shapeDataArrays):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Area Notice (addressed)"
        self.dataParts = dataParts
        self.shapes = shapeDataArrays
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Message Linkage ID", "Notice Description", "Month (UTC)", "Day (UTC)", "Hour (UTC)", "Minute (UTC)",
            "Duration"
            ]
        updaters.updateType_6_7(self)

# UWAGA: typ wiadomości z tablicą informacji o ładunku (cargos)
datapartsBitlengths['6_8'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 2, 10)
datapartsTypes['6_8'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "e", "u")
class messageType_6_8():
    def __init__(self, dataParts, cargoTypesArray):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Dangerous Cargo Indication"
        self.dataParts = dataParts
        self.cargos = cargoTypesArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Unit of Quantity", "Amount of Cargo"
            ]
        updaters.updateType_6_8(self)

# UWAGA: typ wiadomości z tablicą informacji o punktach odniesienia
# liczba elementów tablicy zawarta w treści wiadomości (waycount)
datapartsBitlengths['6_9'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 10, 3, 5, 4, 5, 5, 6, 18, 5)
datapartsTypes['6_9'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "u", "e", "u", "u", "u", "u", "u", "u")
class messageType_6_9(): 
    def __init__(self, dataParts, waypointArray):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Route Information (addressed)"
        self.dataParts = dataParts
        self.waypoints = waypointArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Message Linkage ID", "Sender Class", "Route Type", "Start month (UTC)", "Start day (UTC)", "Start hour (UTC)",
            "Start minute (UTC)", "Duration", "Waypoints number"
            ]
        updaters.updateType_6_9(self)

# UWAGA: ostatni element (description) jest typu string ("t") i ma długość 6 - 930 bitów
# czyli RÓŻNĄ, ale jest na końcu, więc nie trzeba jej znać - wystarczy index bitu, którym rozpoczyna się
# ten element i wszystko aż do ostatniego bitu będzie bitami tego opisu 
datapartsBitlengths['6_10'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 10)
datapartsTypes['6_10'] = ("u", "u", "u", "u", "u", "u", "x", "u", "u", "u")
class messageType_6_10():
    def __init__ (self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "IMO289 Text description (addressed)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Message Linkage ID", "Description"
            ]
        updaters.updateType_6_10(self)

# Typ wiadomości z tablicą obiektów imo289_tidal
datapartsBitlengths['6_11'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 4, 5)
datapartsTypes['6_11'] = ("u", "u", "u", "u", "u", "b", "x", "u", "u", "u", "u")
class messageType_6_11():
    def __init__(self, dataParts, tidalInfoArray):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "Tidal Window (IMO289)"
        self.dataParts = dataParts
        self.tidals = tidalInfoArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Month", "Day"
            ]
        updaters.updateType_6_11(self)

datapartsBitlengths['6_12'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 12, 18, 30, 30, 30, 4, 5, 5, 6, 3, 12, 5)
datapartsTypes['6_12'] = ("u", "u", "u", "u", "u", "u", "x", "u", "u", "t", "t", "t", "t", "t", "u", "u", "u", "u", "u", "u", "x")
class messageType_6_12():
    def __init__ (self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "ETA at lock/bridge/terminal (Inland AIS)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "UN Country Code", "UN/LOCODE", "Fairway section", "Terminal code", "Fairway hectometre", "ETA month",
            "ETA day", "ETA hour", "ETA minute", "Assisting Tugs", "Air Draught"
            ]
        updaters.updateType_6_12(self)

datapartsBitlengths['6_13'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 12, 18, 30, 30, 30, 4, 5, 5, 6, 2, 2)
datapartsTypes['6_13'] = ("u", "u", "u", "u", "u", "u", "x", "u", "u", "t", "t", "t", "t", "t", "u", "u", "u", "u", "e", "x")
class messageType_6_13():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "RTA at lock/bridge/terminal (Inland AIS)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "UN Country Code", "UN/LOCODE", "Fairway section", "Terminal code", "Fairway hectometre", "RTA month",
            "RTA day", "RTA hour", "RTA minute", "Status"
            ]
        updaters.updateType_6_13(self)

datapartsBitlengths['6_14'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 8, 13, 8, 51)
datapartsTypes['6_14'] = ("u", "u", "u", "u", "u", "u", "x", "u", "u", "u", "u", "u", "x")
class messageType_6_14():
    def __init__(self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "Number of persons on board (Inland AIS)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Number Of Crew On Board", "Number Of Passengers On Board", "Number Of Personnel On Board"
            ]
        updaters.updateType_6_14(self)

datapartsBitlengths['6_15'] = (6, 2, 30, 2, 30, 1, 1, 10, 6, 10, 10, 10, 2, 2, 1, 8, 1, 4)
datapartsTypes['6_15'] = ("u", "u", "u", "u", "u", "u", "x", "u", "u", "u", "u", "u", "u", "u", "b", "u", "b", "x")
class messageType_6_15():
    def __init__ (self, dataParts):
        self.name = "[Type 6] Binary Addressed Message"
        self.subname = "AtoN monitoring data (GLA)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", 
            "DAC", "FID", "Analogue", "Analogue (ext. 1)", "Analogue (ext. 2)", "RACON status", "Light status", "Health",
            "Status (external)", "Position status"
            ]
        updaters.updateType_6_15(self)

# UWAGA: typ z tablicą numerów MMSI celu
datapartsBitlengths['7'] = (6, 2, 30, 2)
datapartsTypes['7'] = ("u", "u", "u", "x")
class messageType_7():
    def __init__(self, dataParts, destinationMMSIs):
        self.name = "[Type 7] Binary Acknowledge"
        self.dataParts = dataParts
        self.destinationMMSIs = destinationMMSIs
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI"
            ]
        updaters.updateType_7(self)

datapartsBitlengths['8_1'] = (6, 2, 30, 2, 10, 6, 24, 25, 5, 5, 6, 7, 7, 9, 9, 11, 7, 10, 9, 2, 8, 9, 2, 8, 9, 8, 9, 5, 8, 9, 5, 8, 6, 9, 8, 6, 9, 4, 10, 3, 9, 2, 6)
datapartsTypes['8_1'] = ("u", "u", "u", "x", "u", "u", "I3", "I3", "u", "u", "u", "u", "u", "u", "u", "u", "u", "u", "u", "e", "U1", "I1", "e", "U1", "u", "U1", "u", "U1", "U1", "u", "U1", "U1", "u", "u", "U1", "u", "u", "e", "U1", "e", "U1", "e", "x")
class messageType_8_1():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "Meteorological and Hydrological Data (IMO236)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Latitude", "Longitude", "Day (UTC)", "Hour (UTC)", "Minute (UTC)",
            "Average Wind Speed", "Gust Speed", "Wind Direction", "Wind Gust Direction", "Air Temperature", "Relative Humidity", "Dew Point",
            "Air Pressure", " Pressure Tendency", "Horizontal Visibility", "Water Level", "Water Level Trend", "Surface Current Speed", 
            "Surface Current Direction", "Current Speed 2", "Current Direction 2", "Measurement Depth 2", "Current Speed 3", "Current Direction 3",
            "Measurement Depth 3", "Wave height", "Wave period", "Wave direction", "Swell height", "Swell period", "Swell direction", "Sea state",
            "Water temperature", "Precipitation", "Salinity", "Ice"
            ]
        updaters.updateType_8_1(self)

datapartsBitlengths['8_2'] = (6, 2, 30, 2, 10, 6, 120, 120, 120, 10, 2, 5, 4, 5, 6, 5, 4, 5, 6, 4)
datapartsTypes['8_2'] = ("u", "u", "u", "x", "u", "u", "t", "t", "t", "u", "u", "u", "u", "u", "u", "u", "u", "u", "u", "x")
class messageType_8_2():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "Fairway Closed"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Reason For Closing", "Location Of Closing From", "Location of Closing To",
            "Radius extension", "Unit of extension", "From day (UTC)", "From month (UTC)", "From hour (UTC)", "From minute (UTC)", "To day (UTC)", 
            "To month (UTC)", "To hour (UTC)", "To minute (UTC)"
            ]
        updaters.updateType_8_2(self)

datapartsBitlengths['8_3'] = (6, 2, 30, 2, 10, 6, 11, 5)
datapartsTypes['8_3'] = ("u", "u", "u", "x", "u", "u", "u", "x")
class messageType_8_3():
    def __init__ (self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO236 Extended Ship Static and Voyage Related Data"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Air Draught"
            ]
        updaters.updateType_8_3(self)

datapartsBitlengths['8_4'] = (6, 2, 30, 2, 10, 6)
datapartsTypes['8_4'] = ("u", "u", "u", "x", "u", "u")
class messageType_8_4():
    def __init__(self, dataParts, targetsArray):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "VTS-Generated/Synthetic targets"
        self.dataParts = dataParts
        self.targets = targetsArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID"
            ]
        updaters.updateType_8_4(self)

datapartsBitlengths['8_5'] = (6, 2, 30, 2, 10, 6, 10, 120, 25, 24, 2, 5, 5, 6, 5, 102)
datapartsTypes['8_5'] = ("u", "u", "u", "x", "u", "u", "u", "t", "I3", "I3", "u", "e", "u", "u", "e", "x")
class messageType_8_5():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Marine Traffic Signal"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Message Linkage ID", "Name of Signal Station",
            "Longitude", "Latitude", "Status of Signal", "Signal In Service", "Hour (UTC)", "Minute (UTC)", "Expected Next Signal"
            ]
        updaters.updateType_8_5(self)

# Podtyp ma różne wersje, zależne od pola (bitu) wmo:
#   jeśli 0 - 8_6_1
#   jeśli 1 - 8_6_2
# weather jest oznaczone jako "u", bo w standardzie nie jeste enumem,
#   ale tak naprawdę jest enumem i jest tabelka z odwzrorowaniem kodów na słowa
datapartsBitlengths['8_6_1'] = (6, 2, 30, 2, 10, 6, 1, 120, 25, 24, 5, 5, 6, 4, 1, 7, 7, 7, 9, 9, 4, 11, 10, 6, 8, 9, 8, 9, 6, 3)
datapartsTypes['8_6_1'] = ("u", "u", "u", "x", "u", "u", "b", "t", "I3", "I3", "u", "u", "u", "u", "b", "U1", "u", "u", "u", "u", "u", "I1", "I1", "u", "U1", "u", "U1", "u", "u", "x")
class messageType_8_6_1():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Weather observation report from ship"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Variant", "Location", "Latitude", "Longitude", "Day (UTC)",
            "Hour (UTC)", "Minute (UTC)", "Present Weather", "Visibility Limit", "Horizontal Visibility", "Relative Humidity",
            "Average Wind Speed", "Wind Direction", "Air Pressure", " Pressure Tendency", "Air Temperature", "Water Temperature", 
            "Wave period", "Wave height", "Wave direction", "Swell height", "Swell direction", "Swell period"
            ]
        updaters.updateType_8_6_1(self)

datapartsBitlengths['8_6_2'] = (6, 2, 30, 2, 10, 6, 1, 16, 15, 4, 6, 5, 3, 7, 5, 7, 11, 10, 4, 7, 8, 7, 8, 8, 7, 10, 7, 9, 6, 9, 5, 5, 4, 4, 6, 6, 6, 7, 5, 6, 6, 5, 6, 6, 5, 6, 7, 3, 3, 5, 4, 5, 5, 4)
datapartsTypes['8_6_2'] =  ("u", "u", "u", "x", "u", "u", "u", "I3", "I3", "u", "u", "u", "u", "u", "U1", "u", "U1", "U1", "u", "u", "u", "u", "U1", "U1", "u", "U1", "u", "U1", "U2", "u", "u", "u", "u", "u", "u", "u", "u", "U2", "u", "u", "u", "u", "U1", "u", "u", "U1", "u", "u", "u", "u", "u", "u", "u", "u")
class messageType_8_6_2():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Weather observation report from ship"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Variant", "Longitude", "Latitude", "Month (UTC)",
            "Day (UTC)", "Hour (UTC)", "Minute (UTC)", "Course Over Ground", "Speed Over Ground", "Heading of the ship", "Pressure at sea level",
            "Pressure Change", "Pressure Tendency", "True Wind Direction", "True Wind Speed", "Relative Wind Direction", "Relative Wind Speed",
            "Maximum Gust Speed", "Maximum Gust Direction", "Air Temperature", "Relative Humidity", "Sea Surface Temperature", "Horizontal Visibility",
            "Present Weather", "Past Weather 1", "Past Weather 2", "Total Cloud Cover", "Cloud amount (low)", "Cloud type (low)", "Cloud type (middle)",
            "Cloud type (high)", "Height of cloud base", "Period of Wind Waves", "Height of Wind Waves", "First Swell Direction", "First Swell Period",
            "First Swell Height", "Second Swell Direction", "Second Swell Period", "Second Swell Height", "Ice deposit (thickness)", "Rate of Ice Accretion",
            "Cause of Ice Accretion", "Sea Ice Concentration", "Amount and Type of Ice", "Ice Situation", "Ice Development", "Bearing of Ice Edge"
            ]
        updaters.updateType_8_6_2(self)

# TA SAMA SYTUACJA CO DLA 6_7
datapartsBitlengths['8_7'] = (6, 2, 30, 2, 10, 6, 10, 7, 4, 5, 5, 6, 18)
datapartsTypes['8_7'] = ("u", "u", "u", "x", "u", "u", "u", "u", "u", "u", "u", "u", "u")
class messageType_8_7():
    def __init__(self, dataParts, shapeDataArrays):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Area Notice (broadcast)"
        self.dataParts = dataParts
        self.shapes = shapeDataArrays
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Message Linkage ID", "Notice Description", "Month (UTC)", "Day (UTC)",
            "Hour (UTC)", "Minute (UTC)", "Duration"
            ]
        updaters.updateType_8_7(self)

datapartsBitlengths['8_8'] = (6, 2, 30, 2, 10, 6, 10, 13, 30, 30, 30, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 18, 12, 42, 18, 2, 2, 2, 2, 14, 13, 10)
datapartsTypes['8_8'] = ("u", "u", "u", "x", "u", "u", "u", "u", "t", "t", "t", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "e", "x", "e", "u", "u", "t", "u", "e", "e", "e", "e", "u", "u", "x")
class messageType_8_8():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Extended Ship Static and Voyage Related Data"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Message Linkage ID", "Air Draught", "Last Port Of Call", "Next Port Of Call",
            "Second Port Of Call", "AIS Class A", "Automatic Tracking Aid", "BNWAS", "ECDIS Back-up", "Paper Nautical Chart", "Echo sounder",
            "Electronic plotting aid", "Emergency steering gear", "GNSS", "Gyro compass", "LRIT", "Magnetic compass", "NAVTEX", "Radar (ARPA)",
            "Radar (S-band)", "Radar (X-band)", "Radio HF", "Radio INMARSAT", "Radio MF", "Radio VHF", "Speed Log over ground", "Speed Log through water",
            "THD", "Track control system", "VDR/S-VDR", "Reserved", "Ice Class", "Shaft Horsepower", "VHF Working Channel", "Lloyd’s Ship Type", 
            "Gross Tonnage", "Laden or Ballast", "Heavy Fuel Oil Bunkered", "Light Fuel Oil Bunkered", "Diesel Oil Bunkered", "Total Bunker Oil", "Number of persons"
            ]
        updaters.updateType_8_8(self)

# UWAGA: typ danych z tablicami informacji o raportach z czujników (reports)
datapartsBitlengths['8_9'] = (6, 2, 30, 2, 10, 6)
datapartsTypes['8_9'] = ("u", "u", "u", "x", "u", "u")
class messageType_8_9():
    def __init__(self, dataParts, reports):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Environmental"
        self.dataParts = dataParts
        self.reports = reports
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID"
        ]
        updaters.updateType_8_9(self)

# UWAGA: TA SAMA CO DLA 6_9
datapartsBitlengths['8_10'] = (6, 2, 30, 2, 10, 6, 10, 3, 5, 4, 5, 5, 6, 18, 5)
datapartsTypes['8_10'] = ("u", "u", "u", "x", "u", "u", "u", "u", "e", "u", "u", "u", "u", "u", "u")
class messageType_8_10():
    def __init__(self, dataParts, waypointArray):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Route Information (broadcast)"
        self.dataParts = dataParts
        self.waypoints = waypointArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Message Linkage ID", "Sender Class", "Route Type", "Start month",
            "Start day", "Start hour", "Start minute", "Duration", "Waypoint count"
        ]
        updaters.updateType_8_10(self)

# UWAGA: TA SAMA CO DLA 6_10
datapartsBitlengths['8_11'] = (6, 2, 30, 2, 10, 6, 10)
datapartsTypes['8_11'] = ("u", "u", "u", "x", "u", "u", "u")
class messageType_8_11():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "IMO289 Text description (broadcast)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Message Linkage ID", "Description"
        ]
        updaters.updateType_8_11(self)

datapartsBitlengths['8_12'] = (6, 2, 30, 2, 10, 6, 25, 24, 1, 5, 5, 6, 7, 7, 9, 9, 11, 7, 10, 9, 2, 7, 8, 12, 2, 8, 9, 8, 9, 5, 8, 9, 5, 8, 6, 9, 8, 6, 9, 4, 10, 3, 9, 2, 10)
datapartsTypes['8_12'] = ("u", "u", "u", "x", "u", "u", "I3", "I3", "b", "u", "u", "u", "u", "u", "u", "u", "I1", "u", "I1", "u", "e", "b", "U1", "I2", "e", "U1", "u", "U1", "u", "U1", "U1", "u", "u", "U1", "u", "u", "U1", "u", "u", "e", "I1", "e", "U1", "u", "x")
class messageType_8_12():
    def __init__ (self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "Meteorological and Hydrological Data (IMO289)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Longitude", "Latitude", "Fix quality", "Day", "Hour", "Minute",
            "Average Wind Speed", "Gust Speed", "Wind Direction", "Wind Gust Direction", "Air Temperature", "Relative Humidity", "Dew Point",
            "Air Pressure", "Pressure Tendency", "Maximum Visibility", "Horizontal Visibility", "Water Level", "Water Level Trend", "Surface Current Speed",
            "Surface Current Direction", "Current Speed 2", "Current Direction 2", "Measurement Depth 2", "Current Speed 3", "Current Direction 3", "Measurement Depth 3",
            "Wave Height", "Wave Period", "Wave Direction", "Swell Height", "Swell Period", "Swell Direction", "Sea State", "Water Temperature",
            "Precipitation", "Salinity", "Ice"
        ]
        updaters.updateType_8_12(self)

datapartsBitlengths['8_13'] = (6, 2, 30, 2, 10, 6, 48, 13, 10, 14, 3, 11, 2, 1, 1, 1, 8)
datapartsTypes['8_13'] = ("u", "u", "u", "x", "u", "u", "t", "u", "u", "e", "e", "u", "e", "b", "b", "b", "x")
class messageType_8_13():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "Inland ship static and voyage related data (Inland AIS)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "European Vessel ID", "Legth of ship", "Beam of ship",
            "Ship/combination type", "Hazardous cargo", "Draught", "Loaded/Unloaded", "Speed inf. quality", "Course inf. quality", "Heading inf. quality"
        ]
        updaters.updateType_8_13(self)

datapartsBitlengths['8_14'] = (6, 2, 30, 2, 10, 6, 8, 4, 5, 8, 3, 5, 5, 6, 5, 6, 28, 27, 28, 27, 4, 9, 9, 2, 4, 6)
datapartsTypes['8_14'] = ("u", "u", "u", "x", "u", "u", "u", "u", "u", "u", "u", "u", "u", "u", "u", "u", "I4", "I4", "I4", "I4", "e", "i", "i", "e", "e", "x")
class messageType_8_14():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "EMMA Warning Report (Inland AIS)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Start year", "Start Month", "Start Day", "End Year", "End Month",
            "End Day", "Start Hour", "Start Minute", "End Hour", "End  Minute", "Start Longitude", "Start Latitude", "End Longitude", "End Latitude",
            "Type", "Minimum value", "Maximum value", "Classification", "Wind Direction"
        ]
        updaters.updateType_8_14(self)

# UWAGA: typ wiadomości z tablicami pomiarów (gauges)
datapartsBitlengths['8_15'] = (6, 2, 30, 2, 10, 6, 12)
datapartsTypes['8_15'] = ("u", "u", "u", "x", "u", "u", "t")
class messageType_8_15():
    def __init__(self, dataParts, gaugeMeasArray):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "Water Levels (Inland AIS)"
        self.dataParts = dataParts
        self.gauges = gaugeMeasArray
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "UN Country Code"
        ]
        updaters.updateType_8_15(self)

datapartsBitlengths['8_16'] = (6, 2, 30, 2, 10, 6, 28, 27, 4, 9, 3, 30, 11)
datapartsTypes['8_16'] = ("u", "u", "u", "x", "u", "u", "I4", "I4", "u", "u", "e", "e", "x")
class messageType_8_16():
    def __init__(self, dataParts):
        self.name = "[Type 8] Binary Broadcast Message"
        self.subname = "Signal Strength (Inland AIS)"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "DAC", "FID", "Signal Longitude", "Signal Latitude", "Signal form",
            "Signal orientation", "Direction of impact", "Light Status"
        ]
        updaters.updateType_8_16(self)

datapartsBitlengths['9'] = (6, 2, 30, 12, 10, 1, 28, 27, 12, 6, 8, 1, 3, 1, 1, 20)
datapartsTypes['9'] = ("u", "u", "u", "u", "u", "u", "I4", "I4", "U1", "u", "x", "b", "x", "b", "b", "u")
class messageType_9():
    def __init__(self, dataParts):
        self.name = "[Type 9] Standard SAR Aircraft Position Report"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Altitude", "SOG", "Position Accuracy", "Longitude", "Latitude", "Course Over Ground",
            "Time Stamp", "Regional reserved", "DTE", "Assigned", "RAIM flag", "Radio status"
        ]
        updaters.updateType_9(self)

datapartsBitlengths['10'] = (6, 2, 30, 2, 30, 2)
datapartsTypes['10'] = ("u", "u", "u", "x", "u", "x")
class messageType_10():
    def __init__(self, dataParts):
        self.name = "[Type 10] UTC/Date Inquiry"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Destination MMSI"
        ]
        updaters.updateType_10(self)

# struktura jak wiadomości typu 4
datapartsBitlengths['4'] = (6, 2, 30, 14, 4, 5, 5, 6, 6, 1, 28, 27, 4, 10, 1, 19)
datapartsTypes['4'] = ("u", "u", "u", "u", "u", "u", "u", "u", "u", "b", "I4", "I4", "e", "x", "b", "u")
class messageType_11():
    def __init__(self, dataParts):
        self.name = "[Type 11] UTC/Date Response"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Year", "Month", "Day", "Hour", "Minute", "Second", "Fix quality", 
            "Longitude", "Latitude", "Type of EPFD", "RAIM flag", "SOTDMA state"
            ]
        updaters.updateType_11(self)

datapartsBitlengths['12'] = (6, 2, 30, 2, 30, 1, 1, 936)
datapartsTypes['12'] = ("u", "u", "u", "u", "u", "b", "x", "t")
class messageType_12():
    def __init__(self, dataParts):
        self.name = "[Type 12] Addressed Safety-Related Message"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Sequence Number", "Destination MMSI", "Retransmit flag", "Text"
            ]
        updaters.updateType_12(self)

# struktura jak wiadomości typu 7
datapartsBitlengths['13'] = (6, 2, 30, 2, 30, 2, 30, 2, 30, 2, 30, 2)
datapartsTypes['13'] = ("u", "u", "u", "x", "u", "u", "u", "u", "u", "u", "u", "u")
class messageType_13():
    def __init__(self, dataParts):
        self.name = "[Type 13] Safety-Related Acknowledgment"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "MMSI number 1", "Sequence for MMSI 1", "MMSI number 2", "Sequence for MMSI 2",
            "MMSI number 3", "Sequence for MMSI 3", "MMSI number 4", "Sequence for MMSI 4"
            ]
        updaters.updateType_13(self)


# UWAGA: wydaje mi się, że w tym przypadku znaki tekstu są 8-bitowe z dwoma zerami na początku
# (patrz uwagę pod tym typem); ale może tylko 2 ostatnie bity są nadmiarowe - dobrze by było o to dopytać
# Siwickiego
datapartsBitlengths['14'] = (6, 2, 30, 2, 968)
datapartsTypes['14'] = ("u", "u", "u", "x", "t")
class messageType_14():
    def __init__(self, dataParts):
        self.name = "[Type 14] Safety-Related Broadcast Message"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Text"
            ]
        updaters.updateType_14(self)

# UWAGA: rzeczywista długość całkowita może być mniejsza od tej wynikającej z poniższej krotki (160 bitów)
#   dekoder musi sprawdzać długość i w odpowiednim momencie olewać kolejne pola krotki
#   (patrz uwagę pod tym typem)
datapartsBitlengths['15'] = (6, 2, 30, 2, 30, 6, 12, 2, 6, 12, 2, 30, 6, 12, 2)
datapartsTypes['15'] = ("u", "u", "u", "x", "u", "u", "u", "x", "u", "u", "x", "u", "u", "u", "x")
class messageType_15():
    def __init__(self, dataParts):
        self.name = "[Type 15] Interrogation"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Interrogated MMSI 1", "First message type 1", "First slot offset 1", "Second message type 1", "Second Slot offset 1",
            "Interrogated MMSI 2", "First message type 2", "First slot offset 2"
            ]
        updaters.updateType_15(self)

# UWAGA: rzeczywista długość całkowita może być mniejsza od tej wynikającej z poniższej krotki (144 bity)
#   dekoder musi sprawdzać długość i w odpowiednim momencie olewać kolejne pola krotki
#   (patrz uwagę pod tym typem)
datapartsBitlengths['16'] = (6, 2, 30, 2, 30, 12, 10, 30, 12, 10)
datapartsTypes['16'] = ("u", "u", "u", "x", "u", "u", "u", "u", "u", "u")
class messageType_16():
    def __init__(self, dataParts):
        self.name = "[Type 16] Assignment Mode Command"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Destination A MMSI", "Offset A", "Increment A",
            "Destination B MMSI", "Offset B", "Increment B"
            ]
        updaters.updateType_16(self)

# UWAGA: ostatnie 736 bitów to MAX (może być mniej, nawet 0) i jest po prostu
#   jakimiś danymi binarnymi (jak na moje nie trzeba ich interpretować)
#   więc w tablicy dataParts można zapisać coś w stylu "<GPS binary data>"
datapartsBitlengths['17'] = (6, 2, 30, 2, 18, 17, 5, 736)
datapartsTypes['17'] = ("u", "u", "u", "x", "I1", "I1", "x", "d")
class messageType_17():
    def __init__(self, dataParts):
        self.name = "[Type 17] DGNSS Broadcast Binary Message"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Longitude", "Latitude", "Payload"
            ]
        updaters.updateType_17(self)

datapartsBitlengths['18'] = (6, 2, 30, 8, 10, 1, 28, 27, 12, 9, 6, 2, 1, 1, 1, 1, 1, 1, 1, 20)
datapartsTypes['18'] = ("u", "u", "u", "x", "U1", "b", "I4", "I4", "U1", "u", "u", "u", "b", "b", "b", "b", "b", "b", "b", "u")
class messageType_18():
    def __init__(self, dataParts):
        self.name = "[Type 18] Standard Class B CS Position Report"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Regional reserved", "Speed Over Ground", "Position Accuracy", "Longitude",
            "Latitude", "Course Over Ground", "True Heading", "Time Stamp", "Regional reserved", "CS Unit", "Display flag", "DSC flag", 
            "Band flag", "Message 22 flag", "Assigned", "RAIM flag", "Radio status"
            ]
        updaters.updateType_18(self)

datapartsBitlengths['19'] = (6, 2, 30, 8, 10, 1, 28, 27, 12 , 9, 6, 4, 120, 8, 9, 9, 6, 6, 4, 1, 1, 1, 4)
datapartsTypes['19'] = ("u", "u", "u", "u", "U1", "b", "I4", "I4", "U1", "u", "u", "u", "t", "u", "u", "u", "u", "u", "e", "b", "b", "u", "x")
class messageType_19():
    def __init__(self, dataParts):
        self.name = "[Type 19] Extended Class B CS Position Report"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Regional reserved", "Speed Over Ground", "Position Accuracy", "Longitude",
            "Latitude", "Course Over Ground", "True Heading", "Time Stamp", "Regional reserved", "Name", "Type of ship and cargo", "Dimension to Bow", "Dimension to Stern",
            "Dimension to Starboard", "Position Fix Type", "RAIM flag", "DTE", "Assigned mode flag"
            ]
        updaters.updateType_19(self)

# UWAGA: tym wiadomości z tablicą zarezerwowanych slotów
datapartsBitlengths['20'] = (6, 2, 30, 2)
datapartsTypes['20'] = ("u", "u", "u", "x")
class messageType_20():
    def __init__(self, dataParts, reservedSlots):
        self.name = "[Type 20] Data Link Management Message"
        self.dataParts = dataParts
        self.reservedSlots = reservedSlots
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI"
            ]
        updaters.updateType_20(self)

# UWAGA: ostatnie pole musi być "przeniesione" do pola o indeksie [4], jeśli pierwotnie w
#   w bitowej reprezentacji to pole ma zajęte wszystkie znaki (tzn. jeśli nie kończy się znakami '@')
# Jeśli w polu [4] są jakieś znaki kończące się na ('@') ostatnie pole należy zignorować (nie zapisywać do tablicy albo do pliku)
# Po szczegółowe informacje patrz uwagę pod typem 
datapartsBitlengths['21'] = (6, 2, 30, 5, 120, 1, 28, 27, 9, 9, 6, 6, 4, 6, 1, 8, 1, 1, 1, 1, 88)
datapartsTypes['21'] = ("u", "u", "u", "e", "t", "b", "I4", "I4", "u", "u", "u", "u", "e", "u", "b", "u", "b", "b", "b", "x", "t")
class messageType_21():
    def __init__(self, dataParts):
        self.name = "[Type 21] Aid-to-Navigation Report"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Aid type", "Name", "Position Accuracy", "Longitude", "Latitude", 
            "Dimension to Bow", "Dimension to Stern", "Dimension to Starboard", "Type of EPFD", "Second (UTC)", "Off-Position Indicator",
            "Regional reserved", "RAIM flag", "Wirtual-aid flag", "Assigned mode flag", "Name Extension"
            ]
        updaters.updateType_21(self)

datapartsBitlengths['22'] = (6, 2, 30, 2, 12, 12, 4, 1, 18, 17, 18, 17, 30, 30, 1, 1, 1, 3, 23)
datapartsTypes['22'] = ("u", "u", "u", "x", "u", "u", "u", "b", "I1", "I1", "I1", "I1", "u", "u", "b", "b", "b", "u", "x")
class messageType_22():
    def __init__(self, dataParts):
        self.name = "[Type 22] Channel Management"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Channel A", "Channel B", "Tx/Rx mode", "Power", "NE Longitude", "NE Latitude",
            "SW Longitude", "SW Latitude", "MMMSI1", "MMSI2", "Addressed", "Channel A Band", "Channel B Band", "Zone size"
            ]
        updaters.updateType_22(self)

# UWAGA: w pewnych warunach wartości z tabeli 66 będą podwojone
datapartsBitlengths['23'] = (6, 2, 30, 2, 18, 17, 18, 17, 4, 8, 22, 2, 4, 4, 6)
datapartsTypes['23'] = ("u", "u", "u", "x", "u", "u", "u", "u", "e", "e", "x", "u", "e", "u", "x")
class messageType_23():
    def __init__(self, dataParts):
        self.name = "[Type 23] Group Assignment Command"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "NE Longitude", "NE Latitude", "SW Longitude", "SW Latitude", "Station Type",
            "Ship Type", "Tx/Rx Mode", "Report Interval", "Quiet Time"
            ]
        updaters.updateType_23(self)

# UWAGA: zawartość jest różnie interpretowana w zależności od tego, czy jest to typ A czy B
#   informacja o tym, jaki to typ, zawarta jest w polu [3] (Part Number - jeśli 0 to A, a jeśli 1 to B)
# Po więcej potencjalnie istotnych szczegółów patrz uwagę pod typem
datapartsBitlengths['24_A'] = (6, 2, 30, 2, 120, 8)
datapartsTypes['24_A'] = ("u", "u", "u", "u", "t", "x")
class messageType_24_A():
    def __init__(self, dataParts):
        self.name = "[Type 24] Static Data Report"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Part Number", "Vessel Name"
            ]
        updaters.updateType_24_A(self)

datapartsBitlengths['24_B'] = (6, 2, 30, 2, 8, 18, 4, 20, 42, 9, 9, 6, 6, 30, 6)
datapartsTypes['24_B'] = ("u", "u", "u", "u", "e", "t", "u", "u", "t", "u", "u", "u", "u", "u", "x")
class messageType_24_B():
    def __init__(self, dataParts):
        self.name = "[Type 24] Static Data Report"
        self.dataParts = dataParts 
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Part Number", "Ship Type", "Vendor ID", "Unit Model Code",
            "Serial Number", "Call Sign", "Dimension to Bow", "Dimension to Stern", "Dimension to Port", "Dimension to Starboard", "Mothership MMSI"
            ]
        updaters.updateType_24_B(self)

# UWAGA: interpretacja części wiadomości zależy od zawartości niektórych pól
#   jeśli pole [3] jest 1, to pole [5] oznaczaa MMSI celu
#   jeśli pole [3] jest 0, to pole [5] jest danymi binarnymi, przy czym
#       jeśli pole [4] jest 1, to dane binarne (30 bitów) są poprzedzone 16 bitami app_id (10 na DAC i 6 na FID)
#       jeśli pole [4] jest 0, to dane binarne to nie ma app_id (więc w sumie będzie 46 dodatkowych bitów danych - patrz niżej)
#   uwagi do pola [4] dotyczą również sytuacji, gdy [3] jest 1, więc
#       jeśli [3] jest 1 i [4] jest 1, to nie będzie dodatkowych bitów danych
#       jeśli [3] jest 1 a [4] jest 0, to będzie 30 bitów dest_mmsi, a następnie 16+128 (maksymalnie +128) bitów danych (ostatnie pole to 128 bitów danych tak czy siak)
#       jeśli [3] jest 0 a [4] jest 1, to będzie 16 bitów app_id, a następnie 30+128 (maksymalnie +128) bitów danych
#       jeśli [3] jest 0 i [4] jest 0, to nie ma ani dest_mmsi ani app_id, tzn zaraz po polu [4] jest 30+16+128 bitów danych
# Żeby nie mieszać - typy danych i ich długości podane są tylko do pola [4]
# pozostałe trzeba wpisać ręcznie, jeśli będzie taka potrzeba:
#   pole [5] - "u" lub dane binarne nieinterpretowane
#   pole [6] - "u" lub dane binarne nieinterpretowane
# Raczej nie ma sensu wypisywać do pliku danych binarnych, więc proponuję, żeby jedynki i zera
#   zastąpić jednym napisem w stylu "<Binary data>"

# UWAGA 2: typ 25 jest bardzo rzadki - sugeruję zrobić go na końcu, jeśli starczy czasu; po sprawdzeniu wyników
# statystycznych, czy w ogóle występuje w tym pliku; jeśli nie, to nie będzie tragedii, jeśli się go ominie (ale lepiej ofc zrobić)
# pierwsza 1 w typie - flaga adressed, druga - flaga structured

## raczej nie powinno być błędów w związku z dodaniem pustego pola, co najwyżej obiekt będzie miał po prostu niepotrzebne fieldy w środku
datapartsBitlengths['25_11'] = (6, 2, 30, 1, 1, 30, 16, 128)
datapartsTypes['25_11'] = ("u", "u", "u", "b", "b", "u", "u", "d")

datapartsBitlengths['25_10'] = (6, 2, 30, 1, 1, 30, 0, 144)
datapartsTypes['25_10'] = ("u", "u", "u", "b", "b", "u", "z", "d")

datapartsBitlengths['25_01'] = (6, 2, 30, 1, 1, 0, 16, 158)
datapartsTypes['25_01'] = ("u", "u", "u", "b", "b", "z", "u", "d")

datapartsBitlengths['25_00'] = (6, 2, 30, 1, 1, 0, 0, 174)
datapartsTypes['25_00'] = ("u", "u", "u", "b", "b", "z", "z", "d")

class messageType_25():
    def __init__(self, dataParts):
        self.name = "[Type 25] Single Slot Binary Message"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Destination indicator", "Binary data flag", "Destination MMSI", "Application ID", "Data"
            ]
        updaters.updateType_25(self)

# UWAGA (1 i 2): takie same jak dla typu 25, z tą różnicą, że podstawowe pole danych binarnych ma długość maksymalnie 1004 bity (a nie 128)
# UWAGA 3: ostatnie 20 bitów (po nieinterpretowanych danych binarnych) jest informacją "radio status"
#   w razie gdyby było to przydatne: w pythonie są legalne indeksy ujemne: 
#       [-1] oznacza ostatni element listy (tablicy)
#       [-2] oznacza drugi element od końca itd
datapartsBitlengths['26_11'] = (6, 2, 30, 1, 1, 30, 16, 1004)
datapartsTypes['26_11'] = ("u", "u", "u", "b", "b", "u", "u", "d")

datapartsBitlengths['26_10'] = (6, 2, 30, 1, 1, 30, 0, 1020)
datapartsTypes['26_10'] = ("u", "u", "u", "b", "b", "u", "z", "d")

datapartsBitlengths['26_01'] = (6, 2, 30, 1, 1, 0, 16, 1034)
datapartsTypes['26_01'] = ("u", "u", "u", "b", "b", "z", "u", "d")

datapartsBitlengths['26_00'] = (6, 2, 30, 1, 1, 0, 0, 1050)
datapartsTypes['26_00'] = ("u", "u", "u", "b", "b", "z", "z", "d")
class messageType_26():
    def __init__(self, dataParts):
        self.name = "[Type 26] Multiple Slot Binary Message"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Destination indicator", "Binary data flag", "Destination MMSI", "Application ID",
            "Data", "Radio status"
            ]
        updaters.updateType_25(self)

datapartsBitlengths['27'] = (6, 2, 30, 1, 1, 4, 18, 17, 6, 9, 1, 1)
datapartsTypes['27'] = ("u", "u", "u", "u", "u", "u", "I4", "I4", "u", "u", "u", "x")
class messageType_27():
    def __init__(self, dataParts):
        self.name = "[Type 27] Long Range AIS Broadcast message"
        self.dataParts = dataParts
        self.fields = [
            "Message Type", "Repeat Indicator", "Source MMSI", "Position Accuracy", "RAIM flag", "Navigation Status", "Longitude", "Latitude",
            "Speed Over Ground", "Course Over Ground", "GNSS Position status"
            ]
        updaters.updateType_27(self)