import math
#from Aggregates import message_aggregates ##?

#konwersja do unsigned int/enum/bool dowolnej liczby bitów
def decode_u_int(fragment):
    value = int(fragment, 2)
    return value

#konwersja do signed int dowolnej liczby bitów
def decode_s_int(fragment):             #, bits): , bits i tak będzie nadpisywane
    byte = int(fragment, 2)
    bits = len(fragment)
    if byte > ((2**(bits-1)) - 1):
        value = (2**bits - byte) * (-1)
    else:
        value = byte
    return value
    ##bits = ilość bitów w elemencie krotki
    ##byte = konwersja na wartośći int zapisu bitowego we fragmencie

#konwersja ciagów 6-bitowych na string w 6-bit ASCII
def decode_t(fragment):
    value = ""
    bits = len(fragment)
    max = math.floor(bits/6)
    i = 0
    while i < max:
        x = fragment[6*i:6*i+6]
        y = int(x, 2)
        if y < 32:
            z = chr(y+64)
        if y > 32:
            z = chr(y)
        value += z
        i += 1
    return value
    ## bits = długość fragmentu w bitach
    ## max = maksymalna ilość bitów podzielna bez reszty przez 6
    ## x = wycinek fragmentu, który określa kolejne 6 bitów
    ## y = wartość x w int
    ## z = wartość y w 6-bit ASCII

#konwersja ciągu bitowego na format U1 i U2
def decode_UX(fragment, type):
    ## jeżeli jakimś cudem się zdarzy, że fragment jest pusty, to to nas chroni :D
    if len(fragment) == 0:
        fragment = '0'
    number = str(int(fragment, 2))
    prefix = ""
    length = len(number)
    if length - type == -1:
        value = float('.0' + number)
    if length - type > -1:
        prefix = number[0:-(type)]
        suffix = number[-(type):]
        value = float(prefix+'.'+suffix)
    return value
    ## number, raz w zapisie int, raz w str
    ## length, długość stringa number w int
    ## prefix, cyfry przed przecinkiem
    ## suffix, cyfry po przecinku

#konwersja ciągu bitowego na format I1, I2, I3, I4
def decode_IX(fragment, type):
    ##konwersja na bezwzgledna wartosc z signed int + zachowanie znaku
    sign = 0
    bits = len(fragment)
    ## jeżeli jakimś cudem się zdarzy, że fragment jest pusty, to to nas chroni :D
    if len(fragment) == 0:
        fragment = '0'
        bits = 1

    byte = int(fragment, 2)
    if byte > ((2**(bits-1)) - 1):
        number = (2**bits - byte)
        sign = 1
    else:
        number = byte
    number = str(number)
    length = len(number)

    if (length - type) == (-3):
        value = float('.000'+ number)
    if (length - type) == (-2):
        value = float('.00'+ number)
    if (length - type) == (-1):
        value = float('.0'+ number)
    if length - type > -1:
        prefix = number[0:(-type)]
        suffix = number[(-type):]
        value = float(prefix+'.'+suffix)
        
    if sign == 1:
        value = value * (-1)
    return value
    ## sign - flaga znaku, która jest uwzględniana po przetworzeniu liczby do IX
    ## sign - flaga znaku, która jest uwzględniana po przetworzeniu liczby do IX