import os.path
import codecs
from datetime import datetime

def printMessage(message):
    filename = str(message.dataParts[message.fields.index("Source MMSI")]) + ".txt"
    topDir = "AIS messages"
    messageDir = message.name
    if hasattr(message, 'subname'):
        messageSubDir = message.subname    
        filePath = os.path.join(topDir, messageDir, messageSubDir, filename)
        try:
            os.mkdir(os.path.join(topDir, messageDir))
            os.mkdir(os.path.join(topDir, messageDir, messageSubDir))
        except Exception:
            pass
    else:
        filePath = os.path.join(topDir, messageDir, filename)
        try:
            os.mkdir(os.path.join(topDir, messageDir))
        except Exception:
            pass
    
    if os.path.isfile(filePath):
        print("Próbowano nadpisać: " + filePath)
    else:
        with open(filePath, 'w') as file_object:
            for field, value in zip(message.fields, message.dataParts):
                file_object.write(field + ": " + str(value) + "\n")

def printStats(stats):
    print("Wszystkich wiadomosci: {}".format(stats["all"]))
    print("Wiadomości pojedynczych: {ile} ({proc}%)".format(ile=stats["single"], proc=round(100*stats["single"]/stats["all"],2)))
    print("Wiadomości podwójnych: {ile} ({proc}%)".format(ile=stats["double"], proc=round(100*stats["double"]/stats["all"],2)))
    print("Wiadomości z błędną sumą kontrolną: {ile} ({proc}%)".format(ile=stats["defective"], proc=round(100*stats["defective"]/stats["all"],2)))
    print("Wiadomości bez zawartości: {ile} ({proc}%)".format(ile=stats["empty"], proc=round(100*stats["empty"]/stats["all"],2)))
    for i in range(len(stats["types"])):
        print("Wiadomości typu {}".format(i+1) +": {ile} ({proc}%)".format(ile=stats["types"][i], proc=round(100*stats["types"][i]/stats["all"],2)))
    
    now = datetime.now()
    current_time = now.strftime("%H:%M:%S")
    print("\nCzas wykonania przetwarzania =", current_time)    
    
    filename = "stats.txt"
    with codecs.open(filename, 'w', "utf-8") as file_object:
        file_object.write("Wszystkich wiadomosci: {}".format(stats["all"]) + "\n")
        file_object.write("Wiadomości pojedynczych: {ile} ({proc}%)".format(ile=stats["single"], proc=round(100*stats["single"]/stats["all"],2)) + "\n")
        file_object.write("Wiadomości podwójnych: {ile} ({proc}%)".format(ile=stats["double"], proc=round(100*stats["double"]/stats["all"],2)) + "\n")
        file_object.write("Wiadomości z błędną sumą kontrolną: {ile} ({proc}%)".format(ile=stats["defective"], proc=round(100*stats["defective"]/stats["all"],2)) + "\n")
        file_object.write("Wiadomości bez zawartości: {ile} ({proc}%)".format(ile=stats["empty"], proc=round(100*stats["empty"]/stats["all"],2)) + "\n")
        for i in range(len(stats["types"])):
            file_object.write("Wiadomości typu {}".format(i+1) +": {ile} ({proc}%)".format(ile=stats["types"][i], proc=round(100*stats["types"][i]/stats["all"],2)) + "\n")
        file_object.write("\nCzas wykonania przetwarzania = {}".format(current_time))
